// Mesure de temperature avec TC74
// Fichier TC74.cpp
#include <iostream> 
#include <bcm2835.h>
#include <math.h>
using namespace std;

#define clk_div BCM2835_I2C_CLOCK_DIVIDER_2500

// g++ -o TC74 bcm2835.cpp TC74.cpp

void init_I2c_bcm2835()
{
	if (!bcm2835_init())
    		{
      		printf("bcm2835_init failed. Are you running as root??\n");
    		}
      	if (!bcm2835_i2c_begin())
      		{
        	printf("bcm2835_i2c_begin failed. Are you running as root??\n");
      		}
	bcm2835_i2c_setClockDivider(clk_div);			// Division de l'horloge Rpi pour obtenir une vitesse de 100KHz
}

int main(void)
{
	int temperature;
	unsigned int slave_address=0x4d; // Adresse du TC74
	char i2cOut[3]; 	// Tableau des données I2C à sortir 
	char i2cIn[2];		// Tableau des données I2C entrées

	init_I2c_bcm2835();
	bcm2835_i2c_setSlaveAddress(slave_address);	// Affectation de l'adresse de l'esclave 
	cout<<"Mesures de température avec le TC74 : "<<endl;

	delay(1000);					// 1 seconde avant première lecture

	while(1)
		{
		// Mesure température
		bcm2835_i2c_read(i2cIn,1);	// Lecture de la température
		//cout<<"i2cIn[0] = "<< (int)i2cIn[0]<< "      i2cIn[1] = "<< (int)i2cIn[1]<<endl;
		temperature=i2cIn[0];			// affectation Temperature
		cout<<"Temperature du TC74 : "<<temperature<<" deg."<<endl;
		delay(2000);									// 1 seconde entre chaque conversion
   		}

	bcm2835_close();
	return 0;
}
